package com.isu.gaswellwatch.entity;

import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.ToString;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.time.LocalDateTime;

/**
 * 区块对象 blocks
 * 
 * @author scwsl
 * @date 2024-11-17
 */
@Getter
@Setter
@NoArgsConstructor
@ToString(callSuper = true)
@EqualsAndHashCode(callSuper = true)
public class Block extends Model<Block>  {

    private static final long serialVersionUID = 1L;

    /** 主键 */
    private Long id;

    /** 上级标识 */
    private Long parentId;

    /** 名称 */
    private String name;

    /** 描述 */
    private String details;

    /** 是否已删除 */
    private Integer deleted;

    /** 创建人 */
    private Long createBy;

    /** 创建时间 */
    private LocalDateTime createTime;

    /** 更新人 */
    private Long updateBy;

    /** 更新时间 */
    private LocalDateTime updateTime;


}
