package com.isu.gaswellwatch.mapper;


import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.MappingTarget;

import com.isu.gaswellwatch.entity.Block;
import com.isu.gaswellwatch.dto.BlockCreateRequest;
import com.isu.gaswellwatch.dto.BlockEditRequest;
import com.isu.gaswellwatch.vo.BlockVO;
import com.isu.gaswellwatch.vo.UserLoginInfoVO;

import cn.dev33.satoken.stp.StpUtil;
import com.isu.gaswellwatch.constants.UserConstant;

import java.time.LocalDateTime;
import java.util.Objects;
import java.util.List;

/**
 * 区块Mapper blocks
 *
 * @author scwsl
 * @date 2024-11-17
 */
@Mapper
public interface  BlockMapper {

    void create(BlockCreateRequest request, @MappingTarget Block block);

    @Mapping(target = "id", ignore = true)
    void copyToEntity(BlockEditRequest request, @MappingTarget Block block);

    BlockVO toPageVO(Block entity);

    List<BlockVO> toPageVO(List<Block> entities);

    default void copy(BlockEditRequest request, Block block) {
        UserLoginInfoVO userLoginInfoVO = (UserLoginInfoVO) StpUtil.getTokenSession()
                .get(UserConstant.TOKEN_SESSION);
        if (Objects.nonNull(userLoginInfoVO) && Objects.nonNull(userLoginInfoVO.getUserVO())) {
            block.setUpdateBy(block.getCreateBy());
        }
        block.setUpdateTime(LocalDateTime.now());
        copyToEntity(request, block);
    }

    default Block create(BlockCreateRequest request) {
        UserLoginInfoVO userLoginInfoVO = (UserLoginInfoVO) StpUtil.getTokenSession()
                .get(UserConstant.TOKEN_SESSION);
        Block block =new Block();
        block.setCreateTime(LocalDateTime.now());
        block.setUpdateTime(block.getCreateTime());
        if (Objects.nonNull(userLoginInfoVO) && Objects.nonNull(userLoginInfoVO.getUserVO())) {
            block.setCreateBy(userLoginInfoVO.getUserVO().getId());
            block.setUpdateBy(block.getCreateBy());
        }
        create(request, block);
        return block;
    }

}
